--[[ 
Creator: AelitePrime 
	Script Name: IP Alias Script
	Website: http://phasorscripts.wordpress.com/
	Xfire: eliteprime14789x
	Version: 1.0
]]--

ipalias = {}

function GetRequiredVersion()
	return 200
end

function OnScriptLoad(process, game, persistent)
	profilepath = getprofilepath()
	local file = io.open(profilepath .. "\\data\\ip_alias.data", "r")
	if file then
		local ip = ""
		for line in file:lines() do
			if string.sub(line, 1, 1) == "[" then
				ip = string.sub(line, 2, string.len(line)-1)
				ipalias[ip] = {}
				ipalias[ip].name = {}
				ipalias[ip].hash = {}
			else
				if ip then
					local words = tokenizestring(line, ",")
					words[1] = string.sub(words[1], 6)
					for i = 1,#words do
						if words[i] and words[i] ~= "" and words[i] ~= nil then
							if string.sub(line, 1, 4) == "name" then
								table.insert(ipalias[ip].name, words[i])
							else
								table.insert(ipalias[ip].hash, words[i])
							end
						end
					end
				end
			end
		end
	end
end

function OnScriptUnload()
	local file = io.open(profilepath .. "\\data\\ip_alias.data", "w")
	for k,v in pairs(ipalias) do
		if ipalias[k] ~= nil and ipalias[k] ~= {} then
			file:write("[" .. k .. "]\n")
			line = "name="
			for key,value in ipairs(ipalias[k].name) do
				line = line .. value .. ","
			end
			file:write(line .. "\n")
			line = "hash="
			for key,value in ipairs(ipalias[k].hash) do
				line = line .. value .. ","
			end
			file:write(line .. "\n")
		end
	end
	for i=0,15 do
		if getplayer(i) then
			checkipalias(i)
		end
	end
end

function OnServerCommand(player, command)
	local response = nil
	local t = tokenizecmdstring(command)
	local count = #t
	if t[1] == "sv_ipalias_search" then
		response = false
		Command_IpaliasSearch(player, t[1], t[2], count)
	elseif t[1] == "sv_alias_ip" then
		response = false
		Command_Ipalias(player, t[1], t[2], count)
	end
	return response
end

function OnPlayerJoin(player)
	checkipalias(player)
end

function Command_Ipalias(executor, command, player, count)
	if count == 2 then
		local response = "Fetching results....\n"
		local ipcount = 0
		local ip = ""
		local count = 0
		if player then
			local words = tokenizestring(player, ".")
			ipcount = #words
		end
		if ipcount == 4 then
			ip = player
		elseif ipcount > 1 then
			response = "Invalid IP Address Format (xxx.xxx.xxx.xxx)"
		else
			player = tonumber(player)-1
			if player and getplayer(player) then
				ip = getip(player)
			else
				response = "Invalid Player"
			end
		end
		if ip then
			local temp_count = 0
			if ipalias[ip] ~= nil and ipalias[ip] ~= {} then
				for key,value in ipairs(ipalias[ip].name) do
					response = response .. value .. "              "
					temp_count = temp_count + 1
					if temp_count%4 == 0 then
						response = response .. "\n"
					end
					count = count + 1
				end
			end
			response = response .. "\n"
			local temp_count = 0
			if ipalias[ip] ~= nil and ipalias[ip] ~= {} then
				for key,value in ipairs(ipalias[ip].hash) do
					response = response .. value .. "              "
					temp_count = temp_count + 1
					if temp_count%4 == 0 then
						response = response .. "\n"
					end
					count = count + 1
				end
			end
			if tonumber(player) then
				response = response .. "\n" .. count .. " results that matched your search for player index: '" .. player+1 .. "'"
			else
				response = response .. "\n" .. count .. " results that matched your search for '" .. player .. "'"
			end
		else
			response = "Error! Invalid IP"
		end
		sendresponse(response, command, executor)
	else
		sendresponse("Invalid Syntax: " .. command .. " [ip or player]", command, executor)
	end
end

function Command_IpaliasSearch(executor, command, player, count)
	if count == 2 then
		local count = 0
		local response = "Fetching results....\n"
		if string.len(player) < 32 then
				response = response .. "The following names have the same IP:\n"
				for k,v in pairs(ipalias) do
					if ipalias[k] ~= nil and ipalias[k] ~= {} then
						for key,value in ipairs(ipalias[k].name) do
							if value == player then
								response = response .. player .. " - " .. k .. "\n"
								count = count + 1
							end
						end
					end
				end
		elseif string.len(player) == 32 then
			response = response .. "The following IP's have the same hash:\n"
			for k,v in pairs(ipalias) do
				if ipalias[k] ~= nil and ipalias[k] ~= {} then
					for key,value in ipairs(ipalias[k].hash) do
						if player == value then
							response = response .. k .. "\n"
							count = count + 1
						end
					end
				end
			end
		else
			sendresponse("Invalid Syntax: " .. command .. " [name or hash]", command, executor)
		end
		response = response .. count .. " results that matched your search for '" .. player .. "'"
		sendresponse(response, command, executor)
	else
		sendresponse("Invalid Syntax: " .. command .. " [name or hash]", command, executor)
	end
end

function checkipalias(player)
	local name = getname(player)
	local hash = gethash(player)
	local ip = getip(player)
	local bool = false
	for k,v in pairs(ipalias) do
		if ip == k then
			bool = true
		end
	end
	if bool then
		if ipalias[ip] ~= nil and ipalias[ip] ~= {} then
			if ipalias[ip].name ~= nil and ipalias[ip].name ~= {} then
				local temp_bool = true
				for key,value in ipairs(ipalias[ip].name) do
					if value == name then
						temp_bool = false
					end
				end
				if temp_bool then
					table.insert(ipalias[ip].name, name)
				end
			end
			if ipalias[ip].hash ~= nil and ipalias[ip].hash ~= {} then
				local temp_bool = true
				for key,value in ipairs(ipalias[ip].hash) do
					if value == hash then
						temp_bool = false
					end
				end
				if temp_bool then
					table.insert(ipalias[ip].hash, hash)
				end
			end
		end
	else
		ipalias[ip] = {}
		ipalias[ip].name = {}
		ipalias[ip].hash = {}
		table.insert(ipalias[ip].name, name)
		table.insert(ipalias[ip].hash, hash)
	end
end

function sendresponse(message, command, player, log)
	if message then
		if message == "" then 
			return 
		elseif type(message) == "table" then
			message = message[1]
		end
		player = tonumber(player)
		if tonumber(player) and player ~= nil and player ~= -1 and player >= 0 and player < 16 then
			sendconsoletext(player, message)
		else
			hprintf(message)
		end
	end
end